# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define without_tests %{?_without_tests:1}%{!?_without_tests:0}
%define with_tests %{!?_without_tests:1}%{?_without_tests:0}

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section   free

Name:           derby
Version:        10.1.1.0
Release:        1jpp
Epoch:          0
Summary:        Derby DB (ex Cloudscape)

Group:          Database
License:        Apache License Version 2.0
URL:            http://db.apache.org/derby/
Source0:        http://www.apache.org/dist/db/derby/db-derby-10.1.1.0/db-derby-10.1.1.0-src.tar.gz
Source1:        derby-10.1.1.0-test.script
Patch0:         derby-10.1.1.0-compilepath_properties.patch
Patch1:         derby-10.1.1.0-extrapath_properties.patch
Patch2:         derby-10.1.1.0-JDBC30only-BrokeredConnection.patch
Patch3:         derby-10.1.1.0-JDBC30only-BrokeredCallableStatement.patch
Patch4:         derby-10.1.1.0-JDBC30only-BrokeredPreparedStatement.patch
Patch5:         derby-10.1.1.0-JDBC30only-BrokeredCallableStatement30.patch
Patch6:         derby-10.1.1.0-JDBC30only-BrokeredConnection30.patch
Patch7:         derby-10.1.1.0-JDBC30only-EmbedConnection.patch
Patch8:         derby-10.1.1.0-JDBC30only-EmbedCallableStatement20.patch
Patch9:         derby-10.1.1.0-JDBC30only-EmbedPreparedStatement20.patch

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Distribution:   JPackage
Vendor:         JPackage Project

BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  java-devel >= 0:1.4.2
BuildRequires:  javacc
BuildRequires:  jta
BuildRequires:  oro
BuildRequires:  servletapi5
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
Requires:  java >= 0:1.4.2
Requires:  jta
Requires:  oro
Requires:  servletapi5
Requires:  xalan-j2
Requires:  xerces-j2
Requires:  xml-commons-apis

%description
The Derby project develops open source database technology 
that is: Pure Java, Easy to use, Small footprint, Standards 
based, Secure.
The core of the technology, Derby.s database engine is a 
full functioned relational embedded database engine. JDBC 
and SQL are the programming APIs. 
The Derby network server increases the reach of the Derby 
database engine by providing traditional client server 
functionality. The network server allows clients to connect 
over TCP/IP using the standard DRDA protocol. The network 
server allows the Derby engine to support networked JDBC, 
ODBC/CLI, Perl and PHP. 
Database Utilities:
ij -- a tool that allows SQL scripts to be executed against 
      any JDBC database. 
dblook -- Schema extraction tool for a Derby database. 
sysinfo -- Utility to display version numbers and class path. 


%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description    javadoc
Javadoc for %{name}

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
Documents for %{name}

%package        demo
Summary:        Examples for %{name}
Group:          Development/Documentation

%description    demo
Examples for %{name}

%prep
%setup -q -n db-%{name}-%{version}-src

for j in $(find . -name "*.jar"); do
	mv $j $j.no
done

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -b .sav
%patch9 -b .sav

%build
pushd tools/java
ln -sf $(build-classpath javacc) .
ln -sf $(build-classpath jta) .
ln -sf $(build-classpath jce) .
ln -sf $(build-classpath servletapi5) .
ln -sf $(build-classpath oro) .
ln -sf $(build-classpath xalan-j2) .
ln -sf $(build-classpath xerces-j2) .
ln -sf $(build-classpath xml-commons-apis) .
popd

export OPT_JAR_LIST="ant/ant-nodeps"
# set both jres to 1.4.2 !!
ant \
	-Dj13lib=/usr/lib/jvm/java-1.4.2/jre/lib \
	-Dj14lib=/usr/lib/jvm/java-1.4.2/jre/lib \
	buildsource testing buildjarsclean javadoc

%if %{with_tests}
mkdir testdir
cp %{SOURCE1} testdir/testderby.sh
pushd testdir
chmod +x testderby.sh
./testderby.sh
for f in $(find . -name "*.fail"); do
	echo FAILED $f
	cat $f
done
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -pm 644 jars/sane/derbyclient.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyclient-%{version}.jar
install -pm 644 jars/sane/derby.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derby-%{version}.jar
install -pm 644 jars/sane/derbyLocale_de_DE.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_de_DE-%{version}.jar
install -pm 644 jars/sane/derbyLocale_es.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_es-%{version}.jar
install -pm 644 jars/sane/derbyLocale_fr.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_fr-%{version}.jar
install -pm 644 jars/sane/derbyLocale_it.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_it-%{version}.jar
install -pm 644 jars/sane/derbyLocale_ja_JP.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_ja_JP-%{version}.jar
install -pm 644 jars/sane/derbyLocale_ko_KR.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_ko_KR-%{version}.jar
install -pm 644 jars/sane/derbyLocale_pt_BR.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_pt_BR-%{version}.jar
install -pm 644 jars/sane/derbyLocale_zh_CN.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_zh_CN-%{version}.jar
install -pm 644 jars/sane/derbyLocale_zh_TW.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_zh_TW-%{version}.jar
install -pm 644 jars/sane/derbynet.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbynet-%{version}.jar
install -pm 644 jars/sane/derbyTesting.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyTesting-%{version}.jar
install -pm 644 jars/sane/derbytools.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbytools-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 jars/sane/derby.war \
	$RPM_BUILD_ROOT%{_datadir}/%{name}/derby-%{version}.war
install -pm 644 CHANGES $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 COPYRIGHT $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 LICENSE $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 NOTICE $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 STATUS $RPM_BUILD_ROOT%{_datadir}/%{name}

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr javadoc/publishedapi $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr javadoc/engine $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}
cp -pr javadoc/language $RPM_BUILD_ROOT%{_docdir}/%{name}
cp -pr javadoc/tools $RPM_BUILD_ROOT%{_docdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}
%{_datadir}/%{name}
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/derby*-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}

%changelog
* Wed Oct 11 2006 Ralph Apel <r.apel at r-apel.de> - 0:10.1.1.0-1jpp
- Update to 10.1.1.0
- Repatch to JDK14/JDBC3 only
- Add post/postun Requires for javadoc
- Add gcj_support option

* Fri May 19 2006 Fernando Nasser <fnasser@redhat.com> - 0:10.0.2.1-3jpp
- First JPP 1.7 build

* Fri Mar 11 2005 Ralph Apel <r.apel at r-apel.de> - 0:10.0.2.1-2jpp
- Scrap jndi references
- Add OPT_JAR_LIST with ant/ant-nodeps

* Tue Feb 08 2005 Ralph Apel <r.apel at r-apel.de> - 0:10.0.2.1-1jpp
- First JPackage release
- Naively patched to NOT require Java-1.3 nor its extensions
- Tests pass successfully
